@inject Backend back
@inject Observatory obz
@inject Waiter wagter
@implements IDisposable

<h4>Game config</h4><!-- host config -->
@if(wagter.GetState("awaitingInitialConfig")){
    <p>Loading config...</p>
}else{
    <div class="input-group mb-3" style="margin-top: 6px;">
        <div class="input-group-prepend">
            <span class="input-group-text">Hand size</span>
        </div>
        <input type="number" class="form-control" aria-label="Hand size" @bind="localConfig[0]">
    </div>
    <div class="input-group mb-3" style="margin-top: 6px;">
        <div class="input-group-prepend">
            <span class="input-group-text">Player limit</span>
        </div>
        <input type="number" class="form-control" aria-label="Player limit" @bind="localConfig[1]">
    </div>
    <div class="input-group mb-3" style="margin-top: 6px; margin-bottom: 12px;">
        <div class="input-group-prepend">
            <span class="input-group-text">Round limit</span>
        </div>
        <input type="number" class="form-control" aria-label="Round limit" @bind="localConfig[2]">
    </div>
    <SpinButton OnClickCallback="OnUpdateConfigClick" SpinningKey="awaitingConfig">Update Config</SpinButton>
}


@code {

    private string[] localConfig {get;set;} = new string[3];

    [Parameter]
    public Dictionary<string, string> ConfigData {get;set;} = null;

    protected override void OnInitialized(){
        obz.Register<ConfigMessage>("CONFIG_UPDATED", OnConfigUpdated, "ConfigComponent");
        obz.Register<ErrorMessage>("ERR", OnServerError, "ConfigComponent");

        if (!wagter.StateSet("awaitingInitialConfig"))
            wagter.SetState("awaitingInitialConfig", true);
    }

    protected override void OnParametersSet(){
        if (this.ConfigData != null)
            this.localConfig = new string[]{
                ConfigData["HAND_SIZE"],
                ConfigData["PLAYER_LIMIT"],
                ConfigData["ROUND_LIMIT"],
            };
    }

    private void OnConfigUpdated(ConfigMessage msg){
        // config state updated via param

        wagter.SetState("awaitingConfig", false);

        if (wagter.GetState("awaitingInitialConfig")) wagter.SetState("awaitingInitialConfig", false);
        else obz.Notify("toast", new ToastData("Game config changed"));

        base.StateHasChanged();
    }

    private void OnUpdateConfigClick(){
        wagter.SetState("awaitingConfig", true);

        var msg = new ConfigMessage(false);
        var cfgData = new ConfigData();
        cfgData.config = new Dictionary<string, string>{
            ["HAND_SIZE"] = localConfig[0],
            ["PLAYER_LIMIT"] = localConfig[1],
            ["ROUND_LIMIT"] = localConfig[2],
        };
        msg.data = cfgData;

        back.SendMessage(msg);
    }

    private void OnServerError(ErrorMessage msg){
        if (msg.data.info.Contains("config"))
            wagter.SetState("awaitingConfig", false);
    }

    public void Dispose(){
        obz.Deregister("ConfigComponent");
    }

}